;==========================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;==========================

ORG 4084

@DFILE=400C

;============================
;Encoder for screen compression by XAVSNAP
;Revised 09/15 by GCH
;============================
	LD HL,XBUFFER+8
	INC HL
	EX DE,HL
	LD HL,XBUFFER+8
	LD (HL),00
	LD BC,0300
	LDIR		;CLEAN DATA BUFFER.
	CALL MAIN
	EX DE,HL
	LD (HL),40	;EXIT CODE
	INC HL
	LD (HL),01
	LD DE,XBUFFER+8
	SBC HL,DE
	LD B,H		;ASSIGN DATA LEN
	LD C,L		;TO BC (USR VALUE)
	RET
@MAIN
	LD DE,XBUFFER+8	;BUFFER OFFSET
	LD HL,(DFILE)	;VIDEO RAM OFFSET
	INC HL
	LD B,18		;Lines counter (24 lines)
@RET1
	LD A,(HL)
@RET2
	LD C,00		;CHAR COUNTER=0 (<255)
;=====================
;ARRAY Loop.
;Breaked if the counter reaches 255
;and 76 tag is ignored.
;=====================
@RET2B
	INC C		;CHAR COUNTER
	INC HL		;VIDEO ADDRESS 
	EX AF		;AF=SAVE CHAR.
	LD A,(HL)	;TEST for EOL
	CP 76
	JR NZ NXTLINE	;IF NOT
	DEC B		;ELSE
	LD A,B		;UP TO 24 lines?
	JR NZ NOTDONE
			;Write last DATA to XBUFFER
	LD A,01
	CP C		;Character count
	DEC HL		;Last DFILE address
	LD A,(HL)	;Last charcter code
	JR Z LAST1	;Single character
	OR 40		;Multi character
	LD (DE),A	;Save multi char. code
	INC DE
	LD A,C
@LAST1
	LD (DE),A	;Save single char. or multi. char. count
	INC DE		
	RET
@NOTDONE
	INC HL
@NXTLINE
	LD A,C
	CP FF		;TEST IF COUNTER=255
	JR Z ENDLOOPFF	;RESET COUNTER END WRITE FF
	EX AF		;Restore Char
	CP (HL)		;TEST IF THE VALUE IS EQUAL
	JR Z RET2B	;LOOP
@ENDLOOP
	EX AF		;AF=COUNTER v
@ENDLOOPFF
	DEC HL
	OR A
	LD A,C
	SUB 2
	JR NC ADDARRAY	;More than 2 bytes (ARRAY).
	EX AF		;AF=VALUE ^
@ADD1B
	LD (DE),A	;WRITE SINGLE CHAR.
	INC DE
@RET3
	INC HL
	JR RET1
@ADDARRAY		;WRITE 2BYTES. (CHAR AND BIT6)+(MULTI)
	EX AF		;AF=VALUE ^
@ADDARRAYFF
	OR 40
	LD (DE),A	;CHAR+MULTI-TAG
	INC DE
	LD A,C		;MULTI
	JR ADD1B
@XBUFFER
